# -*- coding: utf-8 -*-
from setuphelpers import *

# Declaring specific app values (TO CHANGE)
bin_name_string = "MobaXterm_installer_%s.msi"


def update_package():
    print("Download/Update package content from upstream binary sources")

    from waptpackage import PackageEntry
    import requests

    # Initializing variables
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()

    # Update transition from BeautifulSoup 3 to 4
    try:
        import bs4 as BeautifulSoup
    except:
        import BeautifulSoup

    # Specific app values
    app_name = control.name
    url = control.sources

    # Getting latest version from official website
    page = requests.get(url, headers={"User-Agent": "Mozilla/5.0 (Windows NT 6.1; Win64; x64)"}).text
    bs = BeautifulSoup.BeautifulSoup(page)
    # bs = BeautifulSoup.BeautifulSoup(page,features="html.parser") # For bs4 only
    bs_raw_string = bs.find("a", {"class": "btn_vert"})
    url_dl = bs_raw_string["href"]
    # https://download.mobatek.net/1242019111120613/MobaXterm_Installer_v12.4.zip

    latest_zip = url_dl.split("/")[-1]

    print("Download url is: " + url_dl)

    # Downloading latest binaries
    if not isfile(latest_zip):
        print("Downloading: " + latest_zip)
        wget(url_dl, latest_zip, proxies=proxies)

        # Deleting outdated binaries
        remove_file("MobaXterm_installer.dat")
        for bin_in_dir in glob.glob("*.exe") or glob.glob("*.msi"):
            print("Binary: " + bin_in_dir + " Deleted")
            remove_file(bin_in_dir)

        # Extracting
        print("Extracting " + latest_zip)
        Sevenz_path = makepath(programfiles, "7-Zip", "7z.exe")
        run('"%s" x %s' % (Sevenz_path, latest_zip))
        remove_file(latest_zip)

        # Getting version number
        for bin_in_dir in glob.glob("*.exe") or glob.glob("*.msi"):
            version = (bin_in_dir.split("_")[-1]).replace(".msi", "")
            latest_bin = bin_in_dir

        print("Latest " + app_name + " version is: " + version)

        # Checking version from file
        version_from_file = get_version_from_binary(latest_bin)
        # if not version_from_file.startswith(version) and version_from_file != '':
        if Version(version_from_file) != Version(version) and version_from_file != "":
            print("Changing version to the version number of the binary (from: %s to: %s)" % (version, version_from_file))
            os.rename(latest_bin, bin_name_string % version_from_file)
            version = version_from_file
        else:
            print("Binary file version corresponds to online version")
        # Change version of the package
        print("Writing " + version + "-0 in WAPT\\control")
        pe = PackageEntry()
        pe.load_control_from_wapt(os.getcwd())

        pe.version = version + "-0"
        pe.save_control_to_wapt(os.getcwd())
        print("Update package done. You can now build-upload your package")
    else:
        print("This package is already up-to-date")
